package ru.curoviyxru.vk4me;

import javax.microedition.midlet.*;
import javax.microedition.rms.*;

import vk4me.*;
import vk4me.req.UsersGetReq;
import vk4me.res.TokenRes;
import vk4me.res.UsersRes;
import vk4me.ui.AboutForm;
import vk4me.ui.DialogsList;
import vk4me.ui.MainList;
import vk4me.ui.SettingsForm;
import vk4me.ui.LoginForm;

import javax.microedition.lcdui.*;

public class VK4ME extends MIDlet
{
    private static MIDlet midlet;
    private static LoginForm loginForm;
    private static MainList mainList;
    private static Display display;
    public static Settings settings;
    private static DialogsList dialogsList;
    private static AboutForm aboutForm;
    private static SettingsForm settingsForm;
    public static LongPoll longPoll;
    
    public static Display getDisplay() {
        return VK4ME.display;
    }
    
    public static void log(final String s) {
        if (VK4ME.settings != null && VK4ME.settings.writeDebug) {
            System.out.println("[VK4ME]: " + s);
        }
    }
    
    public static void logout() {
        initLogin();
    }
    
    public static void exit() {
        writeConfig();
        VK4ME.midlet.notifyDestroyed();
    }
    
    public static void showAboutForm(final boolean aBoolean42) {
        if (VK4ME.aboutForm == null) {
            VK4ME.aboutForm = new AboutForm();
        }
        VK4ME.aboutForm.aBoolean42 = aBoolean42;
        VK4ME.display.setCurrent((Displayable)VK4ME.aboutForm);
    }
    
    protected void startApp() {
        VK4ME.midlet = this;
        VK4ME.display = Display.getDisplay((MIDlet)this);
        if ((VK4ME.settings = BaseUtils.readConfig()).account != null) {
            initLoggedIn(null);
            return;
        }
        initLogin();
    }
    
    public static void writeConfig() {
        Settings aClass61_43 = VK4ME.settings;
        try {
            final RecordStore openRecordStore = RecordStore.openRecordStore("appconfig", true);
            try {
                if (aClass61_43 == null) {
                    aClass61_43 = new Settings();
                }
                final String string;
                final byte[] bytes = (string = aClass61_43.buildJson().toString()).getBytes();
                try {
                    if (openRecordStore.getNumRecords() > 0) {
                        openRecordStore.setRecord(1, bytes, 0, bytes.length);
                    }
                    else {
                        openRecordStore.addRecord(bytes, 0, bytes.length);
                    }
                }
                catch (Exception ex3) {
                    openRecordStore.addRecord(bytes, 0, bytes.length);
                    openRecordStore.setRecord(1, bytes, 0, bytes.length);
                }
                log("[WRITE_RECORD]: " + string);
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
            openRecordStore.closeRecordStore();
        }
        catch (Exception ex2) {
            ex2.printStackTrace();
        }
    }
    
    public static void initLogin() {
        VK4ME.settings.account = null;
        writeConfig();
        if (VK4ME.longPoll != null) {
            VK4ME.longPoll.interrupt();
        }
        VK4ME.longPoll = null;
        VK4ME.mainList = null;
        VK4ME.dialogsList = null;
        Images.clear();
        if (VK4ME.loginForm == null) {
            VK4ME.loginForm = new LoginForm();
        }
        VK4ME.display.setCurrent((Displayable)VK4ME.loginForm);
    }
    
    public static void showDialogsList() {
        VK4ME.display.setCurrent((Displayable)VK4ME.dialogsList);
    }
    
    public static void showMainList() {
        VK4ME.display.setCurrent((Displayable)VK4ME.mainList);
    }
    
    public static Account getAccount() {
        return VK4ME.settings.account;
    }
    
    public static void alert(final String s, final boolean b, final Displayable displayable) {
        final Alert current;
        (current = new Alert(b ? "\u041e\u0448\u0438\u0431\u043a\u0430" : "\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435", s, (Image)null, b ? AlertType.ERROR : AlertType.INFO)).setTimeout(3000);
        if (displayable != null) {
            VK4ME.display.setCurrent(current, displayable);
            return;
        }
        VK4ME.display.setCurrent((Displayable)current);
    }
    
    public static void initLoggedIn(final TokenRes class22) {
        if (class22 != null) {
            VK4ME.settings.account = new Account(class22.access_token, class22.user_id);
        }
        writeConfig();
        (VK4ME.longPoll = new LongPoll(VK4ME.settings.account)).start();
        final Account aClass3_115 = VK4ME.settings.account;
        final UsersRes class23 = (UsersRes)new UsersGetReq().request(aClass3_115);
        final int anInt9 = aClass3_115.id;
        if (class23 != null && class23.firstUserValid()) {
            aClass3_115.parse(class23.firstUser().buildJson());
        }
        aClass3_115.id = anInt9;
        VK4ME.loginForm = null;
        VK4ME.dialogsList = new DialogsList();
        if (VK4ME.mainList == null) {
            VK4ME.mainList = new MainList();
        }
        showMainList();
    }
    
    protected void destroyApp(final boolean b) {
    }
    
    protected void pauseApp() {
    }
    
    public static void method45(final int n, final int n2) {
        new Class59(n, n2).start();
    }
    
    public static void showSettingsForm(final boolean aBoolean86) {
        if (VK4ME.settingsForm == null) {
            VK4ME.settingsForm = new SettingsForm();
        }
        VK4ME.settingsForm.aBoolean86 = aBoolean86;
        VK4ME.settingsForm.show();
        VK4ME.display.setCurrent((Displayable)VK4ME.settingsForm);
    }
    
    public static void method48(final int n, final int n2) {
        new Class60(n, n2).start();
    }
}
