package vk4me;
import java.io.*;
import ru.curoviyxru.vk4me.*;
import vk4me.json.JSONObject;

import javax.microedition.rms.*;

public class BaseUtils
{
    private static Network apiParams;
    static ApiLinks apiLinks;
    
    public static final Network getApiParams() {
        if (BaseUtils.apiParams == null) {
            BaseUtils.apiParams = new ApiParams();
        }
        return BaseUtils.apiParams;
    }
    
    public static final ApiLinks getApiLinks() {
        if (BaseUtils.apiLinks == null) {
        	if(VK4ME.settings.useHTTPS) {
        		BaseUtils.apiLinks = new VKApiLinks();
        	} else {
        		BaseUtils.apiLinks = new XtrafrancyzApiLinks();
        	}
            
        }
        return BaseUtils.apiLinks;
    }
    
    public static String getBytes(final InputStream inputStream) throws IOException {
        final ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        final byte[] array = new byte[1024];
        int read;
        while ((read = inputStream.read(array)) != -1) {
            byteArrayOutputStream.write(array, 0, read);
        }
        inputStream.close();
        return new String(byteArrayOutputStream.toByteArray(), "UTF-8");
    }
    
    public static Settings readConfig() {
        try {
            final RecordStore openRecordStore = RecordStore.openRecordStore("appconfig", true);
            try {
                if (openRecordStore.getNumRecords() > 0) {
                    final String s = new String(openRecordStore.getRecord(1), "UTF-8");
                    VK4ME.log("[READ_RECORD]: " + s);
                    final Settings class61 = new Settings();
                    final JSONObject class62 = new JSONObject(s);
                    final Settings class63 = class61;
                    final JSONObject method82;
                    if ((method82 = class62.getObject("account")) != null) {
                        final String method83 = method82.getString("token");
                        final int method84;
                        if ((method84 = method82.getInt("id", 0)) != 0 && !SomeUtils.isEmpty(method83)) {
                            class63.account = new Account(method83, method84);
                        }
                    }
                    class63.savePasswords = class62.getBoolean("savePassword", false);
                    class63.useHTTPS = class62.getBoolean("useHTTPS", false);
                    class63.loadImages = class62.getBoolean("loadImages", false);
                    class63.fastTimeout = class62.getBoolean("fastTimeout", false);
                    class63.writeDebug = class62.getBoolean("writeDebug", false);
                    return class61;
                }
            }
            catch (Exception ex2) {}
            openRecordStore.closeRecordStore();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return new Settings();
    }
}
