package vk4me;
import java.util.*;

import vk4me.json.JSONException;
import vk4me.json.JSONObject;
import vk4me.req.UsersGetReq;
import vk4me.res.UsersRes;

public class Request extends SomeUtils
{
    private String method;
    private String accessToken;
    private Hashtable params;
    private Class resClass;
    
    public boolean ready() {
        return this.hasParams() && this.hasMethod() && !SomeUtils.isEmpty(this.accessToken);
    }
    
    public final Hashtable params() {
        return this.params;
    }
    
    public final Request addParam(final String s, final Object o) {
        if (o != null && !SomeUtils.isEmpty(o.toString()) && !SomeUtils.isEmpty(s)) {
            this.params.put(s, o.toString());
        }
        else if (!SomeUtils.isEmpty(s) && this.params.containsKey(s)) {
            this.params.remove(s);
        }
        return this;
    }
    
    public final Request addParam(final String s, final int n) {
        return this.addParam(s, String.valueOf(n));
    }
    
    public final Response request(Account class3) {
        this.addParam("access_token", this.accessToken = (class3 = class3).accessToken);
        final String method100;
        if (SomeUtils.isEmpty(method100 = Network.apiRequest(this))) {
            return this.newResponse();
        }
        JSONObject class4;
        try {
            class4 = new JSONObject(method100);
        }
        catch (JSONException class5) {
            class5.printStackTrace();
            class4 = null;
        }
        final Response method101 = this.newResponse();
        if (class4 == null || method101 == null) {
            return method101;
        }
        final Response class6;
        if ((class6 = (Response)method101.parse(class4)) instanceof UsersRes) {
            ((UsersRes)class6).namecase = ((UsersGetReq)this).namecase;
        }
        Profiles.parseProfiles(class6);
        return class6;
    }
    
    private Response newResponse() {
        try {
            return (Response) this.resClass.newInstance();
        }
        catch (Exception ex) {
            ex.printStackTrace();
            return null;
        }
    }
    
    public Request(final Class aClass19, String method) {
        this.resClass = aClass19;
        this.params = new Hashtable();
        this.addParam("v", BaseUtils.getApiParams().method104());
        this.addParam("extended", SomeUtils.asInt(true));
        this.addParam("fields", "photo_50,photo_100,text,views,reposts,likes,status,sex");
        if (!SomeUtils.isEmpty(method)) {
            this.method = method;
        }
    }
    
    public final String makeReqUrl() {
        return String.valueOf(this.method) + "?" + SomeUtils.buildUrl(this);
    }
    
    public final boolean hasMethod() {
        return !SomeUtils.isEmpty(this.method);
    }
    
    public final boolean hasParams() {
        return this.params.size() > 0;
    }
    
    public String toString() {
        return String.valueOf(BaseUtils.getApiLinks().api()) + "method/" + this.makeReqUrl();
    }
}
