package vk4me.json;
import java.util.*;

public final class JSONObject
{
    private Hashtable aHashtable96;
    public static final Object anObject95;
    
    static {
        anObject95 = new JsonNull((byte)0);
    }
    
    public JSONObject() {
        this.aHashtable96 = new Hashtable();
    }
    
    public JSONObject(final JSONStringer class57) throws JSONException {
        this();
        if (class57.method93() != '{') {
            throw class57.jsonException("A JSONObject text must begin with '{'");
        }
        while (true) {
            switch (class57.method93()) {
                case '\0': {
                    throw class57.jsonException("A JSONObject text must end with '}'");
                }
                case '}': {}
                default: {
                    class57.method89();
                    final String string = class57.method94().toString();
                    final char method93;
                    if ((method93 = class57.method93()) == '=') {
                        if (class57.method92() != '>') {
                            class57.method89();
                        }
                    }
                    else if (method93 != ':') {
                        throw class57.jsonException("Expected a ':' after a key");
                    }
                    this.putString(string, class57.method94());
                    switch (class57.method93()) {
                        case ',':
                        case ';': {
                            if (class57.method93() == '}') {
                                return;
                            }
                            class57.method89();
                            continue;
                        }
                        case '}': {
                            return;
                        }
                        default: {
                            throw class57.jsonException("Expected a ',' or '}'");
                        }
                    }
                }
            }
        }
    }
    
    public JSONObject(final String s) throws JSONException {
        this(new JSONStringer(s));
    }
    
    private Object method84(final String s) throws JSONException {
        final Object method86;
        if ((method86 = this.method86(s)) == null) {
            throw new JSONException("JSONObject[" + method87(s) + "] not found.");
        }
        return method86;
    }
    
    private double method85(final String s) throws JSONException {
        final Object method84;
        if ((method84 = this.method84(s)) instanceof Byte) {
            return ((Byte)method84).byteValue();
        }
        if (method84 instanceof Short) {
            return ((Short)method84).shortValue();
        }
        if (method84 instanceof Integer) {
            return ((Integer)method84).intValue();
        }
        if (method84 instanceof Long) {
            return ((Long)method84).longValue();
        }
        if (method84 instanceof Float) {
            return ((Float)method84).doubleValue();
        }
        if (method84 instanceof Double) {
            return ((Double)method84).doubleValue();
        }
        if (method84 instanceof String) {
            try {
                return Double.valueOf((String)method84).doubleValue();
            }
            catch (Exception ex) {
                throw new JSONException("JSONObject[" + method87(s) + "] is not a number.");
            }
        }
        throw new JSONException("JSONObject[" + method87(s) + "] is not a number.");
    }
    
    public final boolean has(final String s) {
        return this.aHashtable96.containsKey(s);
    }
    
    private static String method76(final Object o) throws JSONException {
        if (o == null) {
            throw new JSONException("Null pointer");
        }
        method81(o);
        String s;
        if ((s = o.toString()).indexOf(46) > 0 && s.indexOf(101) < 0 && s.indexOf(69) < 0) {
            while (s.endsWith("0")) {
                s = s.substring(0, s.length() - 1);
            }
            if (s.endsWith(".")) {
                s = s.substring(0, s.length() - 1);
            }
        }
        return s;
    }
    
    private Object method86(final String s) {
        if (s == null) {
            return null;
        }
        return this.aHashtable96.get(s);
    }
    
    public final boolean getBoolean(final String s, final boolean b) {
        try {
            final Object method84;
            if ((method84 = this.method84(s)).equals(Boolean.FALSE) || (method84 instanceof String && ((String)method84).equalsIgnoreCase("false"))) {
                return false;
            }
            if (method84.equals(Boolean.TRUE) || (method84 instanceof String && ((String)method84).equalsIgnoreCase("true"))) {
                return true;
            }
            throw new JSONException("JSONObject[" + method87(s) + "] is not a Boolean.");
        }
        catch (Exception ex) {
            return false;
        }
    }
    
    public final double getDouble(final String s) {
        return this.method72(s, Double.NaN);
    }
    
    private double method72(final String s, final double n) {
        try {
            return Double.parseDouble((String)this.method86(s));
        }
        catch (Exception ex) {
            return Double.NaN;
        }
    }
    
    public final int getInt(final String s, final int n) {
        try {
            final Object method84;
            if ((method84 = this.method84(s)) instanceof Byte) {
                return ((Byte)method84).byteValue();
            }
            if (method84 instanceof Short) {
                return ((Short)method84).shortValue();
            }
            if (method84 instanceof Integer) {
                return ((Integer)method84).intValue();
            }
            if (method84 instanceof Long) {
                return (int) ((Long)method84).longValue();
            }
            if (method84 instanceof Float) {
                return (int) ((Float)method84).doubleValue();
            }
            if (method84 instanceof Double) {
                return (int) ((Double)method84).doubleValue();
            }
            if (method84 instanceof String) {
                return (int)this.method85(s);
            }
            throw new JSONException("JSONObject[" + method87(s) + "] is not a number.");
        }
        catch (Exception ex) {
            return n;
        }
    }
    
    public final JSONArray getArray(final String s) {
        final Object method86;
        if ((method86 = this.method86(s)) instanceof JSONArray) {
            return (JSONArray)method86;
        }
        return null;
    }
    
    public final JSONObject getObject(final String s) {
        final Object method86;
        if ((method86 = this.method86(s)) instanceof JSONObject) {
            return (JSONObject)method86;
        }
        return null;
    }
    
    public final String getString(final String s) {
        final String s2 = "";
        final Object method86;
        if ((method86 = this.method86(s)) != null) {
            return method86.toString();
        }
        return s2;
    }
    
    public final JSONObject putBoolean(final String s, final boolean b) throws JSONException {
        this.putString(s, b ? Boolean.TRUE : Boolean.FALSE);
        return this;
    }
    
    public final JSONObject putInt(final String s, final int n) throws JSONException {
        this.putString(s, new Integer(n));
        return this;
    }
    
    public final JSONObject putString(final String s, final Object o) throws JSONException {
        if (s == null) {
            throw new JSONException("Null key.");
        }
        if (o != null) {
            method81(o);
            this.aHashtable96.put(s, o);
        }
        else {
            this.aHashtable96.remove(s);
        }
        return this;
    }
    
    private static String method87(final String s) {
        if (s == null || s.length() == 0) {
            return "\"\"";
        }
        char char1 = '\0';
        final int length = s.length();
        final StringBuffer sb;
        (sb = new StringBuffer(length + 4)).append('\"');
        for (int i = 0; i < length; ++i) {
            final char c = char1;
            switch (char1 = s.charAt(i)) {
                case '\"':
                case '\\': {
                    sb.append('\\');
                    sb.append(char1);
                    break;
                }
                case '/': {
                    if (c == '<') {
                        sb.append('\\');
                    }
                    sb.append(char1);
                    break;
                }
                case '\b': {
                    sb.append("\\b");
                    break;
                }
                case '\t': {
                    sb.append("\\t");
                    break;
                }
                case '\n': {
                    sb.append("\\n");
                    break;
                }
                case '\f': {
                    sb.append("\\f");
                    break;
                }
                case '\r': {
                    sb.append("\\r");
                    break;
                }
                default: {
                    if (char1 < ' ') {
                        final String string = "000" + Integer.toHexString(char1);
                        sb.append("\\u" + string.substring(string.length() - 4));
                        break;
                    }
                    sb.append(char1);
                    break;
                }
            }
        }
        sb.append('\"');
        return sb.toString();
    }
    
    private static void method81(final Object o) throws JSONException {
        if (o != null) {
            if (o instanceof Double) {
                if (((Double)o).isInfinite() || ((Double)o).isNaN()) {
                    throw new JSONException("JSON does not allow non-finite numbers");
                }
            }
            else if (o instanceof Float && (((Float)o).isInfinite() || ((Float)o).isNaN())) {
                throw new JSONException("JSON does not allow non-finite numbers.");
            }
        }
    }
    
    public final String toString() {
        try {
            final Enumeration keys = this.aHashtable96.keys();
            final StringBuffer sb = new StringBuffer("{");
            while (keys.hasMoreElements()) {
                if (sb.length() > 1) {
                    sb.append(',');
                }
                final Object nextElement = keys.nextElement();
                sb.append(method87(nextElement.toString()));
                sb.append(':');
                sb.append(method75(this.aHashtable96.get(nextElement)));
            }
            sb.append('}');
            return sb.toString();
        }
        catch (Exception ex) {
            return null;
        }
    }
    
    static String method75(final Object o) throws JSONException {
        if (o == null || o.equals(null)) {
            return "null";
        }
        if (o instanceof Class56) {
            String method88;
            try {
                method88 = ((Class56)o).method88();
            }
            catch (Exception ex) {
                throw new JSONException(ex);
            }
            if (method88 instanceof String) {
                return method88;
            }
            throw new JSONException("Bad value from toJSONString: " + (Object)method88);
        }
        else {
            if (o instanceof Float || o instanceof Double || o instanceof Byte || o instanceof Short || o instanceof Integer || o instanceof Long) {
                return method76(o);
            }
            if (o instanceof Boolean || o instanceof JSONObject || o instanceof JSONArray) {
                return o.toString();
            }
            return method87(o.toString());
        }
    }
}
