package vk4me.obj;

import vk4me.SomeUtils;
import vk4me.json.JSONObject;

public class User extends Profile
{
    public int id;
    public int sex;
    private String firstName;
    private String lastName;
    private String deactivated;
    private String photo50;
    private String photo100;
    private String status;
    private boolean closed;
    private boolean canAccessClosed;
    
    public User() {
        super(false);
    }
    
    public final String getAva50() {
        if (!SomeUtils.isEmpty(this.photo50)) {
            return this.photo50;
        }
        return "https://vk.com/images/camera_50.png";
    }
    
    public final int getId() {
        return this.id;
    }
    
    public final String getName() {
        if (this.firstName == null && this.lastName == null) {
            return null;
        }
        return String.valueOf(this.firstName) + " " + this.lastName;
    }
    
    public final JSONObject buildJson() {
        try {
            final JSONObject class54 = new JSONObject();
            if (this.getId() != 0 && ((!super.aBoolean8 && this.getId() > 0) || (super.aBoolean8 && this.getId() < 0))) {
                class54.putInt("id", this.id);
            }
            if (!SomeUtils.isEmpty(this.firstName)) {
                class54.putString("first_name", this.firstName);
            }
            if (!SomeUtils.isEmpty(this.lastName)) {
                class54.putString("last_name", this.lastName);
            }
            if (!SomeUtils.isEmpty(this.deactivated)) {
                class54.putString("deactivated", this.deactivated);
            }
            if (!SomeUtils.isEmpty(this.getAva50())) {
                class54.putString("photo_50", this.photo50);
            }
            if (!SomeUtils.isEmpty(this.getAva100())) {
                class54.putString("photo_100", this.photo100);
            }
            if (!SomeUtils.isEmpty(this.status)) {
                class54.putString("status", this.status);
            }
            class54.putInt("sex", this.sex);
            class54.putBoolean("is_closed", this.closed);
            class54.putBoolean("can_access_closed", this.canAccessClosed);
            return class54;
        }
        catch (Exception ex) {
            return new JSONObject();
        }
    }
    
    public final JsonBuildable parse(final JSONObject class54) {
        if (class54 == null) {
            return this;
        }
        this.id = class54.getInt("id", 0);
        this.sex = class54.getInt("sex", 0);
        this.status = class54.getString("status");
        this.firstName = class54.getString("first_name");
        this.lastName = class54.getString("last_name");
        this.deactivated = class54.getString("deactivated");
        this.photo50 = class54.getString("photo_50");
        this.photo100 = class54.getString("photo_100");
        this.closed = class54.getBoolean("is_closed", false);
        this.canAccessClosed = class54.getBoolean("can_access_closed", false);
        return this;
    }
    
    public final String getAva100() {
        if (!SomeUtils.isEmpty(this.photo100)) {
            return this.photo100;
        }
        return "https://vk.com/images/camera_100.png";
    }
}
