package vk4me.req;

import vk4me.BaseUtils;
import vk4me.Request;
import vk4me.SomeUtils;
import vk4me.res.TokenRes;

public final class TokenReq extends Request
{
    private String username;
    private String password;
    private String code;
    private String captcha_sid;
    private String captcha_key;
    private boolean force_sms;
    
    public TokenReq(final String aString2, final String aString3) {
        super(TokenRes.class, "token");
        this.force_sms = false;
        this.addParam("grant_type", BaseUtils.getApiParams().grant_type());
        this.addParam("client_id", BaseUtils.getApiParams().client_id());
        this.addParam("client_secret", BaseUtils.getApiParams().client_secret());
        this.addParam("scope", BaseUtils.getApiParams().scope());
        this.addParam("2fa_supported", SomeUtils.asInt(true));
        this.addParam("username", this.username = aString2);
        this.addParam("password", this.password = aString3);
    }
    
    public final TokenReq setCode(final String aString5) {
        this.addParam("code", this.code = aString5);
        return this;
    }
    
    public final TokenReq setForceSms(final boolean aBoolean20) {
        this.force_sms = aBoolean20;
        this.addParam("force_sms", this.force_sms ? "1" : null);
        return this;
    }
    
    public final TokenReq setCaptchaSid(final String aString6) {
        this.addParam("captcha_sid", this.captcha_sid = aString6);
        return this;
    }
    
    public final TokenReq setCaptchaKey(final String aString7) {
        this.addParam("captcha_key", this.captcha_key = aString7);
        return this;
    }
    
    public final String toString() {
        return String.valueOf(BaseUtils.getApiLinks().oauth()) + this.makeReqUrl();
    }
    
    public final boolean ready() {
        return this.hasParams() && this.hasMethod() && !SomeUtils.isEmpty(this.username) && !SomeUtils.isEmpty(this.password);
    }
}
